class Entry {
  String title; 
  int[] count = new int[TIME_POINTS];
  color c;
  PVector position = new PVector(0, 0, 0);
  int prevy = 0;
  float size = 0.0;
  float pos_rate = 0.0;
  float size_rate = 0.0;
  
  Entry(String title, int agent_index) {
    this.title = title;
    position.x = agent_index*10 + 50; // spaced every 10 pixels
    c = color(random(255), 100, 255);
    for (int i = 0; i < TIME_POINTS; i++) {
      count[i] = 0; // init with 0
    }
  }
  
  void storeTimePoints(int i, int ct) { 
    if ( i >= 0 && i < TIME_POINTS) {
      count[i] = ct;
    }
  }
  
  boolean updatePosition(int time_index) {
    position.z = time_index * 10;
    // which way are we incrementing y
    if ((position.y + system_rate) <= count[time_index]) { position.y += system_rate; } 
    if ((position.y - system_rate) >= count[time_index]) { position.y -= system_rate; }
    
    if ((int)position.y >= count[time_index] - 5 && 
        (int)position.y <= count[time_index] + 5) { 
      //println("position reached");
      return true;  
    } else { return false; }
  }
  
  void updateSize() {
    // size can maybe also change as the data points move.
    // size of the sphere will be dependent on checkout counts
  }
  
  
  void drawAgent() {
    fill(c);
    noStroke();
    lights();
    pushMatrix();
    translate(position.x + 50, position.y + 50, position.z + 50);
    //ellipse(0, 0, size, size);
    sphere(size);
    popMatrix();
  }
  
  //void drawAgentHistory(int time_index) {
  //  fill(c); 
  //  for (int i = 0; i < time_index; i += 2) {
  //    ellipse(count[i], count[i + 1], size, size);
  //  }
  //}
}
